typedef struct _tagIDWPOINT
{
	int x;
	int y;
	double dValue;
} IDWPOINT;

IDWPOINT m_ppArray[32][32];



//////////////////////////////////////////////////////
// method
//////////////////////////////////////////////////////

void IDWInterpolationForForum()
{

//////////////////////////////////////////////////////
// Read file
//////////////////////////////////////////////////////
	FILE *f = fopen("./signal.txt", "rt");
	if (!f)
	{
		return;
	}

	char ch;
	int nArrayHeight = 0;
	int nArrayWidth = 0;
	char value[32] = {0};
	int xc = 0;
	int yc = 0;

	while ( !feof(f) )
	{
		fread((void*)&ch, sizeof(char), 1, f);
		if ( ch == '\t' )
		{
			nArrayWidth++;
			m_ppArray[xc][yc].x = xc;
			m_ppArray[xc][yc].y = yc;
			m_ppArray[xc][yc++].dValue = atof(value);
			memset(value, 0, 32);
		}
		else if ( ch == '\n' )
		{
			if ( yc != 0 )
			{
				nArrayWidth = yc;
			}
			nArrayHeight = xc;
			xc++;
			yc = 0;
			memset(value, 0, 32);
		}
		else
		{
			strncat(value, (const char*)&ch, 1);
		}
	}

//////////////////////////////////////////////////////
// init
//////////////////////////////////////////////////////

	ap::real_2d_array xy;
	xy.setlength(nArrayHeight * nArrayWidth, 3);

	int k = 0;
	for ( int i = 0; i < nArrayHeight; i++ )
	{
		for ( int j = 0; j < nArrayWidth; j++ )
		{
			xy(k, 0) = i;
			xy(k, 1) = j;
			xy(k, 2) = m_ppArray[i][j].dValue;
			k++;
		}
	}

	ap::real_1d_array x;
	idwinterpolant z1;
	int nx = 2;
	int d = 1;
	int n = nArrayWidth * nArrayHeight;
	int nq = 15;
	int nw = 25;
	bool idwerrors = false;

//////////////////////////////////////////////////////
// build interpolant
//////////////////////////////////////////////////////
	idwbuildmodifiedshepard(xy, n, nx, d, nq, nw, z1);

	x.setlength(nx);

//////////////////////////////////////////////////////
// calc interpolant
//////////////////////////////////////////////////////

	for( int i = 0; i < n; i++ )
	{
		x(0) = xy(i, 2);
		//ap::vmove(&x(0), 1, &xy(i, 2), 1, ap::vlen(0,nx-1));
		double val = idwcalc(z1, x);
		idwerrors = ap::fp_neq(val, xy(i,nx));
	}

	/*for( int i = 0; i < n; i++ )
	{
		ap::vmove(&x(0), 1, &xy(i, 0), 1, ap::vlen(0,nx-1));
		idwerrors = idwerrors||ap::fp_neq(idwcalc(z1, x),xy(i,nx));
	}*/
}